//
//  AppController.m
//  OutlineViewSourceList
//
//  Created by Kevin Wojniak on 4/12/08.
//  Copyright 2008 Kainjow LLC. All rights reserved.
//

#import "AppController.h"
#import "Node.h"


@implementation AppController

- (void)awakeFromNib
{
	rootNode = [[Node alloc] init];
	
	NSArray *names1 = [NSArray arrayWithObjects:@"Red", @"Green", @"Blue", nil];
	NSArray *names2 = [NSArray arrayWithObjects:@"Purple", @"Pink", @"Yellow", nil];
	Node *newNode1 = nil, *newNode2 = nil;
	
	for (NSString *name1 in names1)
	{
		newNode1 = [[Node alloc] init];
		newNode1.name = name1;
		newNode1.isGroup = YES;
		[rootNode.children addObject:newNode1];
		[newNode1 release];
		
		for (NSString *name2 in names2)
		{
			newNode2 = [[Node alloc] init];
			newNode2.name = name2;
			[newNode1.children addObject:newNode2];
			[newNode2 release];
		}
	}
}

- (void)dealloc
{
	[rootNode release];
	[super dealloc];
}

#pragma mark -
#pragma mark Data Source

- (NSInteger)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item
{
	Node *node = (item == nil ? rootNode : (Node *)item);
	return [node.children count];
}

- (id)outlineView:(NSOutlineView *)outlineView child:(NSInteger)index ofItem:(id)item
{
	Node *node = (item == nil ? rootNode : (Node *)item);
	return [node.children objectAtIndex:index];
}

- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item
{
	Node *node = (Node *)item;
	return node.isGroup;
}

- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item
{
	Node *node = (Node *)item;
	return node.name;
}

#pragma mark -
#pragma mark Delegate

- (BOOL)outlineView:(NSOutlineView *)outlineView isGroupItem:(id)item
{
	Node *node = (Node *)item;
	return node.isGroup;
}

@end
